#include <cmath>
#include <string>

#include "setgauss.h"

using namespace std;

FSetGauss::FSetGauss()
{
   stablishedEnv(string("Unknown"));
}

FSetGauss::FSetGauss(double a, double b)
{
   stablishedEnv(string("Unknown"));
   stablishedValues(a,b);
}

FSetGauss::FSetGauss(double a, double b, string name)
{
   stablishedEnv(name);
   stablishedValues(a,b);
}

FSetGauss::~FSetGauss()
{

}

double FSetGauss::fuzzing(double x)
{
	if(x< (*a_points)[0] || x>(*a_points)[1])
		return 0;     
	else
		return 1/exp((x-(((*a_points)[0]+(*a_points)[1])/2))*(x-(((*a_points)[0]+(*a_points)[1])/2)));
}

void FSetGauss::stablishedEnv(string n)
{
   a_points= new vector<double>(2);
   a_name = n;
}

void FSetGauss::stablishedValues(double a, double b)
{
    (*a_points)[0]=a;
	(*a_points)[1]=b;
}
