#ifndef __VAR_H_
#define __VAR_H_

#include <list>
#include <string>
#include <vector>


using namespace std;

class FSet;
class FMU;

class FVar {
   int                         a_counter;
protected:
   list<FSet*>          a_set;
   string                    a_name;
   double                   a_inf;
   double                   a_sup;
   vector<double>** a_values;
   double                  a_x;
public:
   FVar(vector<double>** v){a_values=v;}
   virtual ~FVar(){}

   
   virtual double  getInf(){ return a_inf; }
   virtual void    setInf( double v ){ a_inf=v; }

   virtual double  getSup(){ return a_sup; }
   virtual void    setSup( double v ) { a_sup=v; }

   virtual string  getName(){ return a_name; }
   virtual void    setName( string n ){ a_name = n; }
   
   //Operaciones que trabajan con los conjuntos   
   virtual int     getNumberSets(){ return a_set.size(); }
   virtual void    addSet( FSet* s ){ a_set.push_back(s); }
   virtual void    delSet( FSet* s ){ a_set.remove(s); }
   virtual const list<FSet*>&   getSets(){return a_set;}
   
   virtual vector<double>* getValues(){return *a_values;}
   virtual void  setValues(vector<double>** v){a_values=v;}
   
   void  setupVar();
   void operator=(double value);
   
   virtual void unFuzzing(FMU* uf);   

   virtual void operator()(FSet* set);
   virtual void fuzzing();   
protected:
   virtual void _fuzz(double v);   
};

#endif  //__VAR_H_

